﻿using System;
using System.Windows;

namespace TestLibrary
{
    /// <summary>
    /// 애니메이션 에러 이벤트 인자
    /// </summary>
    public class AnimationErrorEventArgs : RoutedEventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 예외 - Exception

        /// <summary>
        /// 예외
        /// </summary>
        public Exception Exception { get; }

        #endregion
        #region 애니메이션 에러 종류 - ErrorKind

        /// <summary>
        /// 애니메이션 에러 종류
        /// </summary>
        public AnimationErrorKind ErrorKind { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - AnimationErrorEventArgs(source, exception, errorKind)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="source">소스</param>
        /// <param name="exception">예외</param>
        /// <param name="errorKind">애니메이션 에러 종류</param>
        public AnimationErrorEventArgs(object source, Exception exception, AnimationErrorKind errorKind) : base(AnimationBehavior.ErrorEvent, source)
        {
            Exception = exception;
            ErrorKind      = errorKind;
        }

        #endregion
    }
}