using System;
using System.IO;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows.Media.Animation;

using TestLibrary.Decoding;

namespace TestLibrary
{
    /// <summary>
    /// ν ִϸ
    /// </summary>
    public class BrushAnimator : Animator
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ݺ 
        /// </summary>
        private RepeatBehavior repeatBehavior;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 귯 - Brush

        /// <summary>
        /// 귯
        /// </summary>
        public ImageBrush Brush { get; }

        #endregion
        #region ݺ  - RepeatBehavior

        /// <summary>
        /// ݺ 
        /// </summary>
        public RepeatBehavior RepeatBehavior
        {
            get
            {
                return this.repeatBehavior;
            }
            set
            {
                this.repeatBehavior = value;

                OnRepeatBehaviorChanged();
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ִϸ̼ ҽ - AnimationSource

        /// <summary>
        /// ִϸ̼ ҽ
        /// </summary>
        protected override object AnimationSource => Brush;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - BrushAnimator(sourceStream, sourceURI, dataStream, repeatBehavior)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sourceStream">ҽ Ʈ</param>
        /// <param name="sourceURI">ҽ URI</param>
        /// <param name="dataStream">GIF  Ʈ</param>
        /// <param name="repeatBehavior">ݺ </param>
        private BrushAnimator
        (
            Stream         sourceStream,
            Uri            sourceURI,
            GIFDataStream  dataStream,
            RepeatBehavior repeatBehavior
        ) : base(sourceStream, sourceURI, dataStream, repeatBehavior)
        {
            Brush          = new ImageBrush {ImageSource = Bitmap};
            RepeatBehavior = this.repeatBehavior;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ (񵿱) - CreateAsync(sourceURI, repeatBehavior, progress)

        /// <summary>
        /// ϱ (񵿱)
        /// </summary>
        /// <param name="sourceURI">ҽ URI</param>
        /// <param name="repeatBehavior">ݺ </param>
        /// <param name="progress"> ̽</param>
        /// <returns>귯 ִϸ ½ũ</returns>
        public static Task<BrushAnimator> CreateAsync(Uri sourceURI, RepeatBehavior repeatBehavior, IProgress<int> progress = null)
        {
            return CreateCoreAsync
            (
                sourceURI,
                progress,
                (stream, dataStream) => new BrushAnimator(stream, sourceURI, dataStream, repeatBehavior)
            );
        }

        #endregion
        #region ϱ (񵿱) - CreateAsync(sourceStream, repeatBehavior)

        /// <summary>
        /// ϱ (񵿱)
        /// </summary>
        /// <param name="sourceStream">ҽ Ʈ</param>
        /// <param name="repeatBehavior">ݺ </param>
        /// <returns>귯 ִϸ ½ũ</returns>
        public static Task<BrushAnimator> CreateAsync(Stream sourceStream, RepeatBehavior repeatBehavior)
        {
            return CreateCoreAsync
            (
                sourceStream,
                dataStream => new BrushAnimator(sourceStream, null, dataStream, repeatBehavior)
            );
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region  ݺ  ϱ - GetSpecifiedRepeatBehavior()

        /// <summary>
        ///  ݺ  ϱ
        /// </summary>
        /// <returns> ݺ </returns>
        protected override RepeatBehavior GetSpecifiedRepeatBehavior() => RepeatBehavior;

        #endregion
    }
}