using System;
using System.IO;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF ø̼ Ȯ
    /// </summary>
    public class GIFApplicationExtension : GIFExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ȯ ̺
        /// </summary>
        public const int ExtensionLabel = 0xff;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ũ - BlockSize

        /// <summary>
        ///  ũ
        /// </summary>
        public int BlockSize { get; private set; }

        #endregion
        #region ø̼ ĺ - ApplicationIdentifier

        /// <summary>
        /// ø̼ ĺ
        /// </summary>
        public string ApplicationIdentifier { get; private set; }

        #endregion
        #region  ڵ - AuthenticationCode

        /// <summary>
        ///  ڵ
        /// </summary>
        public byte[] AuthenticationCode { get; private set; }

        #endregion
        #region  - Data

        /// <summary>
        /// 
        /// </summary>
        public byte[] Data { get; private set; }

        #endregion

        #region GIF   - Kind

        /// <summary>
        /// GIF  
        /// </summary>
        public override GIFBlockKind Kind
        {
            get
            {
                return GIFBlockKind.SpecialPurpose;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - GIFApplicationExtension()

        /// <summary>
        /// 
        /// </summary>
        private GIFApplicationExtension()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>GIF ø̼ Ȯ ½ũ</returns>
        public static async Task<GIFApplicationExtension> ReadAsync(Stream stream)
        {
            GIFApplicationExtension extension = new GIFApplicationExtension();

            await extension.ReadInternalAsync(stream).ConfigureAwait(false);

            return extension;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream)
        {
            byte[] byteArray = new byte[12];

            await stream.ReadAllAsync(byteArray, 0, byteArray.Length).ConfigureAwait(false);

            BlockSize = byteArray[0];

            if(BlockSize != 11)
            {
                throw GIFHelper.ThrowInvalidBlockSizeException("Application Extension", 11, BlockSize);
            }

            ApplicationIdentifier = GIFHelper.GetString(byteArray, 1, 8);

            byte[] authenticationCode = new byte[3];

            Array.Copy(byteArray, 9, authenticationCode, 0, 3);

            AuthenticationCode = authenticationCode;

            Data = await GIFHelper.ReadDataBlocksAsync(stream).ConfigureAwait(false);
        }

        #endregion
    }
}