using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF 
    /// </summary>
    public abstract class GIFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GIF   - Kind

        /// <summary>
        /// GIF  
        /// </summary>
        public abstract GIFBlockKind Kind { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream, extensionEnumerable)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <param name="extensionEnumerable">GIF Ȯ  </param>
        /// <returns>GIF  ½ũ</returns>
        public static async Task<GIFBlock> ReadAsync(Stream stream, IEnumerable<GIFExtension> extensionEnumerable)
        {
            int blockID = await stream.ReadByteAsync().ConfigureAwait(false);

            if(blockID < 0)
            {
                throw new EndOfStreamException();
            }

            return blockID switch
            {
                GIFExtension.ExtensionIntroducer => await GIFExtension.ReadAsync(stream, extensionEnumerable).ConfigureAwait(false),
                GIFFrame.ImageSeparator => await GIFFrame.ReadAsync(stream, extensionEnumerable).ConfigureAwait(false),
                GIFTrailer.TrailerByte => await GIFTrailer.ReadAsync().ConfigureAwait(false),
                _ => throw GIFHelper.ThrowUnknownBlockTypeException(blockID),
            };
        }

        #endregion
    }
}