using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF Ȯ
    /// </summary>
    public abstract class GIFExtension : GIFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ȯ Ұ
        /// </summary>
        public const int ExtensionIntroducer = 0x21;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream, extensionEnumerable)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <param name="extensionEnumerable">GIF Ȯ  </param>
        /// <returns>GIF Ȯ ½ũ</returns>
        public new static async Task<GIFExtension> ReadAsync(Stream stream, IEnumerable<GIFExtension> extensionEnumerable)
        {
            int label = stream.ReadByte();

            if(label < 0)
            {
                throw new EndOfStreamException();
            }

            return label switch
            {
                GIFGraphicControlExtension.ExtensionLabel => await GIFGraphicControlExtension.ReadAsync(stream).ConfigureAwait(false),
                GIFCommentExtension.ExtensionLabel => await GIFCommentExtension.ReadAsync(stream).ConfigureAwait(false),
                GIFPlainTextExtension.ExtensionLabel => await GIFPlainTextExtension.ReadAsync(stream, extensionEnumerable).ConfigureAwait(false),
                GIFApplicationExtension.ExtensionLabel => await GIFApplicationExtension.ReadAsync(stream).ConfigureAwait(false),
                _ => throw GIFHelper.ThrowUnknownExtensionTypeException(label),
            };
        }

        #endregion
    }
}