using System;
using System.IO;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF ׷ Ʈ Ȯ
    /// </summary>
    public class GIFGraphicControlExtension : GIFExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ȯ ̺
        /// </summary>
        public const int ExtensionLabel = 0xf9;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ũ - BlockSize

        /// <summary>
        ///  ũ
        /// </summary>
        public int BlockSize { get; private set; }

        #endregion
        #region GIF  ó ޼ҵ - DisposalMethod

        /// <summary>
        /// GIF  ó ޼ҵ
        /// </summary>
        public GIFFrameDisposalMethod DisposalMethod { get; private set; }

        #endregion
        #region  Է - UserInput

        /// <summary>
        ///  Է
        /// </summary>
        public bool UserInput { get; private set; }

        #endregion
        #region   - HasTransparency

        /// <summary>
        ///  
        /// </summary>
        public bool HasTransparency { get; private set; }

        #endregion
        #region  - Delay

        /// <summary>
        /// 
        /// </summary>
        public int Delay { get; private set; }

        #endregion
        #region  ε - TransparencyIndex

        /// <summary>
        ///  ε
        /// </summary>
        public int TransparencyIndex { get; private set; }

        #endregion
        #region GIF   - Kind

        /// <summary>
        /// GIF  
        /// </summary>
        public override GIFBlockKind Kind
        {
            get
            {
                return GIFBlockKind.Control;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - GIFGraphicControlExtension()

        /// <summary>
        /// 
        /// </summary>
        private GIFGraphicControlExtension()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>GIF ׷ Ʈ Ȯ ½ũ</returns>
        public static async Task<GIFGraphicControlExtension> ReadAsync(Stream stream)
        {
            GIFGraphicControlExtension extension = new GIFGraphicControlExtension();

            await extension.ReadInternalAsync(stream).ConfigureAwait(false);

            return extension;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream)
        {
            byte[] byteArray = new byte[6];

            await stream.ReadAllAsync(byteArray, 0, byteArray.Length).ConfigureAwait(false);

            BlockSize = byteArray[0];

            if(BlockSize != 4)
            {
                throw GIFHelper.ThrowInvalidBlockSizeException("Graphic Control Extension", 4, BlockSize);
            }

            byte packedField = byteArray[1];

            DisposalMethod = (GIFFrameDisposalMethod) ((packedField & 0x1C) >> 2);

            UserInput = (packedField & 0x02) != 0;

            HasTransparency = (packedField & 0x01) != 0;

            Delay = BitConverter.ToUInt16(byteArray, 2) * 10;

            TransparencyIndex = byteArray[4];
        }

        #endregion
    }
}