using System.IO;
using System.Threading.Tasks;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF 
    /// </summary>
    public class GIFHeader : GIFBlock
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Signature

        /// <summary>
        /// 
        /// </summary>
        public string Signature { get; private set; }

        #endregion
        #region  - Version

        /// <summary>
        /// 
        /// </summary>
        public string Version { get; private set; }

        #endregion
        #region GIF  ȭ  - LogicalScreenDescriptor

        /// <summary>
        /// GIF  ȭ 
        /// </summary>
        public GIFLogicalScreenDescriptor LogicalScreenDescriptor { get; private set; }

        #endregion
        #region GIF   - Kind

        /// <summary>
        /// GIF  
        /// </summary>
        public override GIFBlockKind Kind
        {
            get
            {
                return GIFBlockKind.Other;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - GIFHeader()

        /// <summary>
        /// 
        /// </summary>
        private GIFHeader()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>GIF  ½ũ</returns>
        public static async Task<GIFHeader> ReadAsync(Stream stream)
        {
            GIFHeader header = new GIFHeader();

            await header.ReadInternalAsync(stream).ConfigureAwait(false);

            return header;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream)
        {
            Signature = await GIFHelper.ReadStringAsync(stream, 3).ConfigureAwait(false);

            if(Signature != "GIF")
            {
                throw GIFHelper.ThrowInvalidSignatureException(Signature);
            }

            Version = await GIFHelper.ReadStringAsync(stream, 3).ConfigureAwait(false);

            if(Version != "87a" && Version != "89a")
            {
                throw GIFHelper.ThrowUnsupportedVersionException(Version);
            }

            LogicalScreenDescriptor = await GIFLogicalScreenDescriptor.ReadAsync(stream).ConfigureAwait(false);
        }

        #endregion
    }
}