using System;
using System.IO;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF ̹ 
    /// </summary>
    public class GIFImageDescriptor : IGIFRectangle
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 

        /// <summary>
        /// 
        /// </summary>
        public int Left { get; private set; }

        #endregion
        #region 

        /// <summary>
        /// 
        /// </summary>
        public int Top { get; private set; }

        #endregion
        #region ʺ

        /// <summary>
        /// ʺ
        /// </summary>
        public int Width { get; private set; }

        #endregion
        #region 

        /// <summary>
        /// 
        /// </summary>
        public int Height { get; private set; }

        #endregion
        #region   ̺  

        /// <summary>
        ///   ̺  
        /// </summary>
        public bool HasLocalColorTable { get; private set; }

        #endregion
        #region ͷ̽ - Interlace

        /// <summary>
        /// ͷ̽
        /// </summary>
        public bool Interlace { get; private set; }

        #endregion
        #region   ̺   - IsLocalColorTableSorted

        /// <summary>
        ///   ̺  
        /// </summary>
        public bool IsLocalColorTableSorted { get; private set; }

        #endregion
        #region   ̺ ũ - LocalColorTableSize

        /// <summary>
        ///   ̺ ũ
        /// </summary>
        public int LocalColorTableSize { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - GIFImageDescriptor()

        /// <summary>
        /// 
        /// </summary>
        private GIFImageDescriptor()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>GIF ̹  ½ũ</returns>
        public static async Task<GIFImageDescriptor> ReadAsync(Stream stream)
        {
            GIFImageDescriptor descriptor = new GIFImageDescriptor();

            await descriptor.ReadInternalAsync(stream).ConfigureAwait(false);

            return descriptor;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream)
        {
            byte[] byteArray = new byte[9];

            await stream.ReadAllAsync(byteArray, 0, byteArray.Length).ConfigureAwait(false);

            Left   = BitConverter.ToUInt16(byteArray, 0);
            Top    = BitConverter.ToUInt16(byteArray, 2);
            Width  = BitConverter.ToUInt16(byteArray, 4);
            Height = BitConverter.ToUInt16(byteArray, 6);

            byte packedField = byteArray[8];

            HasLocalColorTable = (packedField & 0x80) != 0;

            Interlace = (packedField & 0x40) != 0;

            IsLocalColorTableSorted = (packedField & 0x20) != 0;

            LocalColorTableSize = 1 << ((packedField & 0x07) + 1);
        }

        #endregion
    }
}