using System;
using System.IO;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF  ȭ 
    /// </summary>
    public class GIFLogicalScreenDescriptor : IGIFRectangle
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        public int Width { get; private set; }

        #endregion
        #region  - Height

        /// <summary>
        /// 
        /// </summary>
        public int Height { get; private set; }

        #endregion
        #region   ̺   - HasGlobalColorTable

        /// <summary>
        ///   ̺  
        /// </summary>
        public bool HasGlobalColorTable { get; private set; }

        #endregion
        #region  ػ - ColorResolution

        /// <summary>
        ///  ػ
        /// </summary>
        public int ColorResolution { get; private set; }

        #endregion
        #region   ̺   - IsGlobalColorTableSorted

        /// <summary>
        ///   ̺  
        /// </summary>
        public bool IsGlobalColorTableSorted { get; private set; }

        #endregion
        #region   ̺ ũ - GlobalColorTableSize

        /// <summary>
        ///   ̺ ũ
        /// </summary>
        public int GlobalColorTableSize { get; private set; }

        #endregion
        #region   ε - BackgroundColorIndex

        /// <summary>
        ///   ε
        /// </summary>
        public int BackgroundColorIndex { get; private set; }

        #endregion
        #region ȼ Ⱦ - PixelAspectRatio

        /// <summary>
        /// ȼ Ⱦ
        /// </summary>
        public double PixelAspectRatio { get; private set; }

        #endregion

        #region  - IGIFRectangle.Left

        /// <summary>
        /// 
        /// </summary>
        int IGIFRectangle.Left
        {
            get
            {
                return 0;
            }
        }

        #endregion
        #region  - IGIFRectangle.Top

        /// <summary>
        /// 
        /// </summary>
        int IGIFRectangle.Top
        {
            get
            {
                return 0;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>GIF  ȭ  ½ũ</returns>
        public static async Task<GIFLogicalScreenDescriptor> ReadAsync(Stream stream)
        {
            GIFLogicalScreenDescriptor descriptor = new GIFLogicalScreenDescriptor();

            await descriptor.ReadInternalAsync(stream).ConfigureAwait(false);

            return descriptor;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream)
        {
            byte[] byteArray = new byte[7];

            await stream.ReadAllAsync(byteArray, 0, byteArray.Length).ConfigureAwait(false);

            Width  = BitConverter.ToUInt16(byteArray, 0);
            Height = BitConverter.ToUInt16(byteArray, 2);

            byte packedField = byteArray[4];

            HasGlobalColorTable = (packedField & 0x80) != 0;

            ColorResolution = ((packedField & 0x70) >> 4) + 1;

            IsGlobalColorTableSorted = (packedField & 0x08) != 0;

            GlobalColorTableSize = 1 << ((packedField & 0x07) + 1);

            BackgroundColorIndex = byteArray[5];

            PixelAspectRatio = byteArray[6] == 0 ? 0.0 : (15 + byteArray[6]) / 64.0;
        }

        #endregion
    }
}