using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

using TestLibrary.Extension;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// GIF  ؽƮ Ȯ
    /// </summary>
    public class GIFPlainTextExtension : GIFExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ȯ ̺
        /// </summary>
        public const int ExtensionLabel = 0x01;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ũ - BlockSize

        /// <summary>
        ///  ũ
        /// </summary>
        public int BlockSize { get; private set; }

        #endregion
        #region  - Left

        /// <summary>
        /// 
        /// </summary>
        public int Left { get; private set; }

        #endregion
        #region  - Top

        /// <summary>
        /// 
        /// </summary>
        public int Top { get; private set; }

        #endregion
        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        public int Width { get; private set; }

        #endregion
        #region  - Height

        /// <summary>
        /// 
        /// </summary>
        public int Height { get; private set; }

        #endregion
        #region  ʺ - CellWidth

        /// <summary>
        ///  ʺ
        /// </summary>
        public int CellWidth { get; private set; }

        #endregion
        #region   - CellHeight

        /// <summary>
        ///  
        /// </summary>
        public int CellHeight { get; private set; }

        #endregion
        #region   ε - ForegroundColorIndex

        /// <summary>
        ///   ε
        /// </summary>
        public int ForegroundColorIndex { get; private set; }

        #endregion
        #region   ε - BackgroundColorIndex

        /// <summary>
        ///   ε
        /// </summary>
        public int BackgroundColorIndex { get; private set; }

        #endregion
        #region ؽƮ - Text

        /// <summary>
        /// ؽƮ
        /// </summary>
        public string Text { get; private set; }

        #endregion
        #region GIF Ȯ Ʈ - ExtensionList

        /// <summary>
        /// GIF Ȯ Ʈ
        /// </summary>
        public IList<GIFExtension> ExtensionList { get; private set; }

        #endregion
        #region GIF   - Kind

        /// <summary>
        /// GIF  
        /// </summary>
        public override GIFBlockKind Kind
        {
            get
            {
                return GIFBlockKind.GraphicRendering;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - GIFPlainTextExtension()

        /// <summary>
        /// 
        /// </summary>
        private GIFPlainTextExtension()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region б (񵿱) - ReadAsync(stream, extensionEnumerable)

        /// <summary>
        /// б (񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <param name="extensionEnumerable">GIF Ȯ  </param>
        /// <returns>GIF  ؽƮ Ȯ</returns>
        public new static async Task<GIFPlainTextExtension> ReadAsync(Stream stream, IEnumerable<GIFExtension> extensionEnumerable)
        {
            GIFPlainTextExtension extension = new GIFPlainTextExtension();

            await extension.ReadInternalAsync(stream, extensionEnumerable).ConfigureAwait(false);

            return extension;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region б (ο, 񵿱) - ReadInternalAsync(stream, extensionEnumerable)

        /// <summary>
        /// б (ο, 񵿱)
        /// </summary>
        /// <param name="stream">Ʈ</param>
        /// <param name="extensionEnumerable">GIF Ȯ  </param>
        /// <returns>½ũ</returns>
        private async Task ReadInternalAsync(Stream stream, IEnumerable<GIFExtension> extensionEnumerable)
        {
            byte[] byteArray1 = new byte[13];

            await stream.ReadAllAsync(byteArray1, 0, byteArray1.Length).ConfigureAwait(false);

            BlockSize = byteArray1[0];

            if(BlockSize != 12)
            {
                throw GIFHelper.ThrowInvalidBlockSizeException("Plain Text Extension", 12, BlockSize);
            }

            Left                 = BitConverter.ToUInt16(byteArray1, 1);
            Top                  = BitConverter.ToUInt16(byteArray1, 3);
            Width                = BitConverter.ToUInt16(byteArray1, 5);
            Height               = BitConverter.ToUInt16(byteArray1, 7);
            CellWidth            = byteArray1[9];
            CellHeight           = byteArray1[10];
            ForegroundColorIndex = byteArray1[11];
            BackgroundColorIndex = byteArray1[12];

            byte[] byteArray2 = await GIFHelper.ReadDataBlocksAsync(stream).ConfigureAwait(false);

            Text = GIFHelper.GetString(byteArray2);

            ExtensionList = extensionEnumerable.ToList().AsReadOnly();
        }

        #endregion
    }
}