﻿using System;
using System.Runtime.Serialization;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// 무효 서명 예외
    /// </summary>
    [Serializable]
    public class InvalidSignatureException : GIFDecoderException
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - InvalidSignatureException(message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        public InvalidSignatureException(string message) : base(message)
        {
        }

        #endregion
        #region 생성자 - InvalidSignatureException(message, innerException)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        /// <param name="innerException">내부 예외</param>
        public InvalidSignatureException(string message, Exception innerException) : base(message, innerException)
        {
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 생성자 - InvalidSignatureException(info, context)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="info">직렬화 정보</param>
        /// <param name="context">스트리밍 컨텍스트</param>
        protected InvalidSignatureException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        #endregion
    }
}