﻿using System;
using System.Runtime.Serialization;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// 알 수 없는 블럭 타입 예외
    /// </summary>
    [Serializable]
    public class UnknownBlockTypeException : GIFDecoderException
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - UnknownBlockTypeException(message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        public UnknownBlockTypeException(string message) : base(message)
        {
        }

        #endregion
        #region 생성자 - UnknownBlockTypeException(message, innerException)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        /// <param name="innerException">내부 예외</param>
        public UnknownBlockTypeException(string message, Exception innerException) : base(message, innerException)
        {
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 생성자 - UnknownBlockTypeException(info, context)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="info">직렬화 정보</param>
        /// <param name="context">스트리밍 컨텍스트</param>
        protected UnknownBlockTypeException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        #endregion
    }
}