﻿using System;
using System.Runtime.Serialization;

namespace TestLibrary.Decoding
{
    /// <summary>
    /// 미지원 GIF 버전 예외
    /// </summary>
    [Serializable]
    public class UnsupportedGIFVersionException : GIFDecoderException
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - UnsupportedGIFVersionException(message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        public UnsupportedGIFVersionException(string message) : base(message)
        {
        }

        #endregion
        #region 생성자 - UnsupportedGIFVersionException(message, innerException)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="message">메시지</param>
        /// <param name="innerException">내부 예외</param>
        public UnsupportedGIFVersionException(string message, Exception innerException) : base(message, innerException)
        {
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 생성자 - UnsupportedGIFVersionException(info, context)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="info">직렬화 정보</param>
        /// <param name="context">스트리밍 컨텍스트</param>
        protected UnsupportedGIFVersionException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        #endregion
    }
}