﻿using System.Windows;

namespace TestLibrary
{
    /// <summary>
    /// 다운로드 진행 이벤트 인자
    /// </summary>
    public class DownloadProgressEventArgs : RoutedEventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행률 - Progress

        /// <summary>
        /// 진행률
        /// </summary>
        public int Progress { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - DownloadProgressEventArgs(source, progress)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="source">소스</param>
        /// <param name="progress">진행률</param>
        public DownloadProgressEventArgs(object source, int progress) : base(AnimationBehavior.DownloadProgressEvent, source)
        {
            Progress = progress;
        }

        #endregion
    }
}