﻿using System.Collections;

namespace TestLibrary.Extension
{
    /// <summary>
    /// 비트 배열 확장
    /// </summary>
    public static class BitArrayExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 16비트 정수 구하기 - ToInt16(bitArray)

        /// <summary>
        /// 16비트 정수 구하기
        /// </summary>
        /// <param name="bitArray">비트 배열</param>
        /// <returns>16비트 정수</returns>
        public static short ToInt16(this BitArray bitArray)
        {
            short value = 0;

            for(int i = bitArray.Length - 1; i >= 0; i--)
            {
                value = (short)((value << 1) + (bitArray[i] ? 1 : 0));
            }

            return value;
        }

        #endregion
    }
}