﻿using System;
using System.Windows.Media.Imaging;

namespace TestLibrary.Extension
{
    /// <summary>
    /// 쓰기 가능 비트맵 확장
    /// </summary>
    public static class WritableBitmapExtension
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Class
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 쓰기 가능 비트맵 잠금 - WriteableBitmapLock

        /// <summary>
        /// 쓰기 가능 비트맵 잠금
        /// </summary>
        public class WriteableBitmapLock : IDisposable
        {
            //////////////////////////////////////////////////////////////////////////////////////////////////// Field
            ////////////////////////////////////////////////////////////////////////////////////////// Private

            #region Field

            /// <summary>
            /// 쓰기 가능 비트맵
            /// </summary>
            private readonly WriteableBitmap bitmap;

            #endregion

            //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region 생성자 - WriteableBitmapLock(bitmap)

            /// <summary>
            /// 생성자
            /// </summary>
            /// <param name="bitmap">쓰기 가능 비트맵</param>
            public WriteableBitmapLock(WriteableBitmap bitmap)
            {
                this.bitmap = bitmap;

                this.bitmap.Lock();
            }

            #endregion

            //////////////////////////////////////////////////////////////////////////////////////////////////// Method
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region 처분하기 - Dispose()

            /// <summary>
            /// 처분하기
            /// </summary>
            public void Dispose()
            {
                this.bitmap.Unlock();
            }

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 범위 내 잠그기 - LockInScope(bitmap)

        /// <summary>
        /// 범위 내 잠그기
        /// </summary>
        /// <param name="bitmap">쓰기 가능 비트맵</param>
        /// <returns>처분 가능 인터페이스</returns>
        public static IDisposable LockInScope(this WriteableBitmap bitmap)
        {
            return new WriteableBitmapLock(bitmap);
        }

        #endregion
    }
}