using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Media.Animation;

namespace TestLibrary
{
    /// <summary>
    /// Ÿ̹ 
    /// </summary>
    public class TimingManager
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ϸ ̺Ʈ - Completed

        /// <summary>
        /// Ϸ ̺Ʈ
        /// </summary>
        public event EventHandler Completed;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ð  Ʈ
        /// </summary>
        private readonly List<TimeSpan> timeSpanList = new List<TimeSpan>();

        /// <summary>
        ///  
        /// </summary>
        private int current;

        /// <summary>
        /// īƮ
        /// </summary>
        private int count;

        /// <summary>
        /// Ϸ 
        /// </summary>
        private bool isComplete;

        /// <summary>
        ///  ð
        /// </summary>
        private TimeSpan elapsed;

        /// <summary>
        /// Ϸ ½ũ
        /// </summary>
        private readonly Task completedTask = Task.FromResult(0);

        /// <summary>
        ///  ½ũ Ϸ ҽ
        /// </summary>
        private TaskCompletionSource<int> pauseTaskCompletionSource;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ݺ  - RepeatBehavior

        /// <summary>
        /// ݺ 
        /// </summary>
        public RepeatBehavior RepeatBehavior { get; set; }

        #endregion
        #region Ϸ  - IsComplete

        /// <summary>
        /// Ϸ 
        /// </summary>
        public bool IsComplete
        {
            get
            {
                return this.isComplete;
            }
            private set
            {
                this.isComplete = value;

                if(value)
                {
                    OnCompleted();
                }
            }
        }

        #endregion
        #region   - IsPaused

        /// <summary>
        ///  
        /// </summary>
        public bool IsPaused { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - TimingManager(repeatBehavior)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="repeatBehavior">ݺ </param>
        public TimingManager(RepeatBehavior repeatBehavior)
        {
            RepeatBehavior = repeatBehavior;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ߰ϱ - Add(timeSpan)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="timeSpan">ð </param>
        public void Add(TimeSpan timeSpan)
        {
            this.timeSpanList.Add(timeSpan);
        }

        #endregion
        #region  óϱ (񵿱) - NextAsync(cancellationToken)

        /// <summary>
        ///  óϱ (񵿱)
        /// </summary>
        /// <param name="cancellationToken"> ū</param>
        /// <returns>ó  ½ũ</returns>
        public async Task<bool> NextAsync(CancellationToken cancellationToken)
        {
            if(IsComplete)
            {
                return false;
            }

            await IsPausedAsync(cancellationToken);

            RepeatBehavior repeatBehavior = RepeatBehavior;

            TimeSpan timeSpan = this.timeSpanList[this.current];

            await Task.Delay(timeSpan, cancellationToken);

            this.current++;

            this.elapsed += timeSpan;

            if(repeatBehavior.HasDuration)
            {
                if(this.elapsed >= repeatBehavior.Duration)
                {
                    IsComplete = true;

                    return false;
                }
            }

            if(this.current >= this.timeSpanList.Count)
            {
                this.count++;

                if(repeatBehavior.HasCount)
                {
                    if(this.count < repeatBehavior.Count)
                    {
                        this.current = 0;

                        return true;
                    }

                    IsComplete = true;

                    return false;
                }
                else
                {
                    this.current = 0;

                    return true;
                }
            }

            return true;
        }

        #endregion
        #region ϱ - Reset()

        /// <summary>
        /// ϱ
        /// </summary>
        public void Reset()
        {
            this.current = 0;

            this.count = 0;

            this.elapsed = TimeSpan.Zero;

            IsComplete = false;
        }

        #endregion
        #region ϱ - Pause()

        /// <summary>
        /// ϱ
        /// </summary>
        public void Pause()
        {
            IsPaused = true;

            this.pauseTaskCompletionSource = new TaskCompletionSource<int>();
        }

        #endregion
        #region ٽ ϱ - Resume()

        /// <summary>
        /// ٽ ϱ
        /// </summary>
        public void Resume()
        {
            TaskCompletionSource<int> source = this.pauseTaskCompletionSource;

            source?.TrySetResult(0);

            this.pauseTaskCompletionSource = null;

            IsPaused = false;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Ϸ óϱ - OnCompleted()

        /// <summary>
        /// Ϸ óϱ
        /// </summary>
        protected virtual void OnCompleted()
        {
            Completed?.Invoke(this, EventArgs.Empty);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region   ϱ (񵿱) - IsPausedAsync(cancellationToken)

        /// <summary>
        ///   ϱ (񵿱)
        /// </summary>
        /// <param name="cancellationToken"> ū</param>
        /// <returns>½ũ</returns>
        private Task IsPausedAsync(CancellationToken cancellationToken)
        {
            TaskCompletionSource<int> source = this.pauseTaskCompletionSource;

            if(source != null)
            {
                return source.Task.WithCancellationToken(cancellationToken);
            }

            return this.completedTask;
        }

        #endregion
    }
}